routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home.index');

Route::get('login/{driver}', 'Auth\LoginController@redirectToProvider')->name('login.provider');
Route::get('login/{driver}/callback', 'Auth\LoginController@handleProviderCallback')->name('login.provider_callback');
Auth::routes();

// admin page

Route::prefix('/admin')->group(function(){
	
	// admin dashboard
	Route::get('/', function(){
		return redirect()->route('dashboard');
	});

	Route::get('/dashboard', function(){
		return view('backend.pages.dashboard');
	})->name('dashboard')->middleware(['auth', 'role:admin']);


	// media
	Route::prefix('media')->group(function(){
		Route::post('uploads', 'MediaController@uploads')->name('media.uploads');
		Route::get('get_data', 'MediaController@getData')->name('media.get_data');
		Route::get('select_data/{id}', 'MediaController@selectData')->name('media.get_data');
	});

	Route::resource('/media', 'MediaController');

	// product
	Route::get('/product/get_data', 'ProductController@getData')->name('product.get_data');
	Route::resource('/product', 'ProductController');

	// category
	Route::get('/category/get_category', 'CategoryController@getCategory');
	Route::get('/category/get_parent', 'CategoryController@getParent');
	Route::resource('/category', 'CategoryController');

	// tags
	Route::resource('/tag', 'TagController');

	// order
	Route::get('/order/get_data', 'OrderController@getData')->name('order.get_data');
	Route::resource('/order', 'OrderController');

	// coupon
	Route::get('/coupon/get_data', 'CouponController@getData')->name('coupon.get_data');
	Route::resource('/coupon', 'CouponController');

	// comments
	Route::get('/review/get_data', 'CommentController@getData')->name('comment.get_data');
	Route::resource('/review', 'CommentController');

	// menu
	Route::get('/menu/get_data', 'MenuController@getData')->name('menu.get_data');
	Route::post('/menu/bulk_edit', 'MenuController@bulkEdit')->name('menu.bulk_edit');
	Route::get('/menu/get_menu', 'MenuController@getMenu')->name('menu.get_menu');
	Route::resource('/menu', 'MenuController');

	// user
	Route::post('/user/upload', 'UserController@upload');
	Route::resource('/user', 'UserController');

	// role
	Route::resource('/role', 'RoleController');

	// permission
	Route::resource('/permission', 'PermissionController');

	// widget
	Route::resource('/widget', 'WidgetController');


});

// Route::get('/home', 'HomeController@index')->name('home');

// cart
Route::post('/cart/bulk_update', 'CartController@bulkUpdate')->name('cart.bulk_update');
Route::get('/cart/remove/{hash}', 'CartController@remove')->name('cart.remove');
Route::get('/cart/coupon', 'CartController@coupon')->name('cart.coupon');
Route::resource('/cart', 'CartController');

// currency
Route::get('currency/{type}', 'CurrencyController@set');

// shop
Route::resource('/shop', 'ShopController');

// review

Route::resource('/review', 'ReviewController');

// shipping
Route::post('/shipping/get_services', 'ShippingController@getServices')->name('shipping.get_shipping');
Route::resource('/shipping', 'ShippingController');

// checkout
Route::get('/checkout/status', 'CheckoutController@status')->name('checkout.status');
Route::get('/checkout/payment', 'CheckoutController@payment')->name('checkout.payment');
Route::resource('/checkout', 'CheckoutController');

// user memeber
Route::get('/user', function(){
	return redirect()->route('user.dashboard');
});

Route::get('/dashboard', function(){
	return redirect()->route('user.dashboard');
});

Route::prefix('/user')->group(function(){
	Route::get('/dashboard', 'MemberController@dashboard')->name('user.dashboard');
	Route::get('/order', 'MemberController@order')->name('user.order');
	Route::get('/wishlist', 'MemberController@wishlist')->name('user.wishlist');
	Route::get('/reviews', 'MemberController@reviews')->name('user.reviews');
	Route::put('/profile/{id}', 'MemberController@profileUpdate')->name('user.profile_update');
	Route::get('/profile', 'MemberController@profile')->name('user.profile');
	Route::get('/settings', 'MemberController@settings')->name('user.settings');
	Route::post('/settings/change_password', 'MemberController@changePassword')->name('user.change_password');
	Route::get('/settings/otp', 'MemberController@otp')->name('user.otp');
	Route::post('/settings/otp_submit', 'MemberController@otpSubmit')->name('user.otp_submit');
	Route::get('/settings/test', 'MemberController@test')->name('user.test');
});

Route::get('/api_test', 'ApiController@index');
Route::get('/api_test/notification', 'ApiController@notification');
Route::get('/api_test/send_message', 'ApiController@sendMessage');
Route::get('/api_test/helio', 'ApiController@helio');

// product details
Route::get('/{slug}', 'ShopController@details')->name('shop.details');

app/Widget.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Widget extends Model
{
    protected $table = 'tb_m_widget';

    public function categories()
    {
    	return $this->belongsTo('App\Category', 'category_parent', 'id');
    }
}

app/Http/Controllers/WidgetController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Category;
use App\Widget;

class WidgetController extends Controller
{
    public function index()
    {
    	$widgets = Widget::with(['categories'])->get();
    	return view('backend.pages.widget.index')
    			->with('widgets', $widgets);

    }

    public function create()
    {
    	$categories = Category::get();

		return view('backend.pages.widget.create')
				->with('categories', $categories);
    }

    public function store(Request $request)
    {
    	$widget = new Widget;
    	$widget->name = $request->name;
		$widget->type = $request->type;
		
		if ($request->type == 'categories') {
			$widget->category_parent = $request->category_parent;
			$widget->limit = $request->limit;
		}

		if ($request->type == 'text') {
			$widget->content = $request->content;
		}

		if ($request->type == 'product') {
			$widget->category_id = $request->category_id;
		}
		
		$widget->save();

		$res = [
					'title' => 'Success',
					'type' => 'success',
					'message' => 'Data saved successfully!'

				];

		return redirect()
					->route('widget.index')
					->with($res);
    }

    public function destroy($id)
    {
    	$widget = Widget::find($id);
    	$widget->delete();

    	$res = [
					'title' => 'Success',
					'type' => 'success',
					'message' => 'Data deleted successfully!'

				];

		return redirect()
					->route('widget.index')
					->with($res);

    }
}

resources/views/backend/pages/widget/create.blade.php
@extends('backend.layouts.master')
@section('title')
Add Widget
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">Add Widget</h1>
	<div class="pull-right">
		<a href="{{ route('widget.index') }}" class="btn btn-primary">Back</a>
	</div>
</div>

<form method="post" action="{{ route('widget.store') }}">
	{{ csrf_field() }}
	<div class="row">
		<div class="col-md-12">
			<div class="panel-content">
				<div class="col-md-12">

					<div class="form-group">
						<label class="control-label">Widget Name</label>
						<input type="text" name="name" placeholder="Widget Name" class="form-control">
					</div>

					<div class="form-group">
						<label class="control-label">Widget Type</label>
						<select name="type" class="select2 form-control" data-placeholder="Select Type">
							<option value=""></option>
							<option value="categories">Categories</option>
							<option value="text">Text</option>
							<option value="product">Product</option>
						</select>
					</div>

					<div class="form-group" id="categories" style="display: none">
						<div class="row">
							<div class="col-md-6">
								<label class="control-label">Category Parent</label>
								<select name="category_parent" class="select2 form-control" data-placeholder="Select Parent">
									<option></option>
									@foreach($categories as $category)
										<option value="{{ $category->id }}">{{ $category->name }}</option>
									@endforeach
								</select>
							</div>
							<div class="col-md-6">
								<label class="control-label">Show limit</label>
								<input type="text" name="limit" placeholder="0" class="form-control number">
							</div>
						</div>
					</div>

					<div class="form-group" id="text" style="display: none">
						<label class="control-label">Text Content</label>
						<textarea class="form-control" rows="10" name="content"></textarea>
					</div>

					<div class="form-group" id="product" style="display: none">
						<label class="control-label">Category</label>
						<select name="category_id" class="select2 form-control" data-placeholder="Select Parent">
							<option></option>
							@foreach($categories as $category)
								<option value="{{ $category->id }}">{{ $category->name }}</option>
							@endforeach
						</select>
					</div>

				</div>

				<div class="col-md-12 text-right">
					<hr>
					<button class="btn btn-default" type="reset">Reset</button>
					<button class="btn btn-primary" type="submit">Save</button>
				</div>

			</div>
		</div>
	</div>
</form>

@endsection

@push('js')
<script src="{{ url('assets/backend/pages/js/widget-add-edit.js') }}"></script>
@endpush

resources/views/backend/pages/widget/index.blade.php
@extends('backend.layouts.master')
@section('title')
Widget
@endsection
@section('content')

<div class="section-heading">
	<h1 class="page-title">Widget</h1>
	<div class="pull-right">
		<a href="{{ route('widget.create') }}" class="btn btn-primary">Add new</a>
	</div>
</div>

<div class="row" style="margin-top: 100px">

	@foreach ($widgets as $widget)
	<div class="col-md-4">
		<div class="panel panel-default">
		  <div class="panel-heading">
		  	{{ $widget->name }}
		  	<div class="pull-right" style="display: inline-block;">
		  		<a class="btn btn-success btn-xs" href="{{ route('widget.edit', $widget->id) }}"><i class="fa fa-pencil"></i></a>
		  		<form style="display: inline-block;" class="form-inline" action="{{ route('widget.destroy', $widget->id) }}" method="post">
		  			{{ csrf_field() }}
		  			{{ method_field('DELETE') }}
		  			<button class="btn btn-danger btn-xs" type="submit"><i class="fa fa-times"></i></a>
		  			</button>
		  		</form>
	  		</div>
		  </div>
		  	<div class="panel-body">
		  		{{ $widget->type }}
		  	</div>
		</div>
	</div>
	@endforeach

</div>

@endsection

@push('js')

@if(session()->has('message'))
<script type="text/javascript">
	show_notification("{{ session('title') }}","{{ session('type') }}","{{ session('message') }}");
</script>
@endif

@endpush